//Soul Imports
import './soul/soulexplodere.js';
import './soul/soulwarder.js';
import './soul/soulrisee.js';
import './soul/sswitch.js';
import './soul/sshot.js';

//End Imports 

import './end/endbeam.js';
import './end/endchaos.js';
import './end/endshot.js';
import './end/teleport.js';
import './end/tpmadness.js';
import './end/tpmadnessactive.js';

//Lightning Imports
import './lightning/greatvoltstrike.js';
import './lightning/greatvoltstrikerise.js';
import './lightning/lightningblitz.js';
import './lightning/lightningbolt.js';
import './lightning/lightningzap.js';
import './lightning/voltrise.js';
import './lightning/voltstrike.js';

//Air Imports
import './air/airfield.js';
import './air/airstrike.js';
import './air/gust.js';
import './air/tornado.js';
import './air/windboost.js';

//Earth Imports
import './earth/crushingtrap.js';
import './earth/earthfortress.js';
import './earth/fortify.js';
import './earth/fyblast.js';
import './earth/georise.js';
import './earth/rockgolem.js';
import './earth/vhtremor.js.js';

//Fire Imports
import './fire/fireball.js';
import './fire/fireblast.js';
import './fire/firedance.js';
import './fire/firepledge.js';
import './fire/firewall.js';
import './fire/flareblitz.js';
import './fire/frenzyflames.js';
import './fire/scorch.js';
import './fire/willowisp.js';

//Frost imports
import './frost/barrage.js';
import './frost/blizzard.js';
import './frost/frostcompresss.js';
import './frost/glacierrain.js';
import './frost/gshot.js';

//Light Imports
import './light/brightshield.js';
import './light/brightshieldr.js';
import './light/cleanse.js';
import './light/flash.js';
import './light/lightprism.js';
import './light/lightprismfall.js';
import './light/lightray.js';
import './light/lightrayr.js';
import './light/luminous.js';
import './light/rayofhope.js';

//Blood Imports
import './blood/bloodlust.js';
import './blood/bloodlustactive.js';
import './blood/bloodslash.js';
import './blood/bloodspike.js';
import './blood/forcebleed.js';
import './blood/vampiricthirst.js';
import './blood/vmtactive.js';

//Dark Imports
import './dark/creaturesofthevoid.js';
import './dark/darkarea.js';
import './dark/darkcoat.js';
import './dark/darkcrystal.js';
import './dark/darkphantom.js';
import './dark/darkrestraints.js';
import './dark/darkshot.js';
import './dark/darkslash.js';
import './dark/darkwave.js';
import './dark/lightlesswaveb.js';
import './dark/lightlesswaveba.js';

//Moonblade Imports
import './moonblade/aquadramslash.js';
import './moonblade/mbslash.js';
import './moonblade/moonblades.js';
import './moonblade/mbwrath.js';
import './moonblade/moonsgrace.js';
import './moonblade/quadramslash.js';

//Shadow Imports
import './shadow/leerydash.js';
import './shadow/ptriangulum.js';
import './shadow/shadowbomb.js';
import './shadow/shshuriken.js';
import './shadow/srage';

//Water Imports
import './water/aquaring.js';
import './water/artificialrain.js';
import './water/drown.js';
import './water/watersplash.js';
import './water/oceanguardian.js';

//Nature Imports
import './nature/pinegrenade.js';
import './nature/thorns.js';
import './nature/pinkblossom.js';
import './nature/healingflower.js';
import './nature/naturespunishment.js';

//Magic Choose Imports
import './choose/airchoose.js';
import './choose/bloodchoose.js';
import './choose/darksummonchoose.js';
import './choose/darkswordchoose.js';
import './choose/earthchoose.js';
import './choose/endchoose.js';
import './choose/firecursechoose.js';
import './choose/firetrickchoose.js';
import './choose/frostchoose.js';
import './choose/lighthealchoose.js';
import './choose/lighthindchoose.js';
import './choose/lightningchoose.js';
import './choose/moonbladechoose.js';
import './choose/shadowchoose.js';
import './choose/soulchoose.js';
import './choose/waterchoose.js';
import './choose/naturechoose.js';

//Extra Magic Imports
import './xtramagic/clearer.js';
import './xtramagic/freeze.js';
import './xtramagic/frostcompress.js';
import './xtramagic/soulexplode.js';
import './xtramagic/soulrise.js';
import './xtramagic/soulswitch.js';

//Weapon Imports

import './weapons/durability.js';
import './weapons/warlockstaff.js';
import './weapons/wraithscythe.js';

//Mana Imports

import './mana/cursedpact.js';
import './mana/emanaessence.js';
import './mana/mageslocator.js';
import './mana/magespact.js';
import './mana/manaessence.js';
import './mana/spawntower.js';
import './mana/tpscroll.js';
import './mana/elixir.js';
import './mana/concoction.js';
import './mana/manabottle.js';
import './mana/antipoison.js';

//Scripts

import { world, Player } from "@minecraft/server"

world.afterEvents.playerSpawn.subscribe((data) => {
    const player = data.player

    if (data.initialSpawn) {
        player.sendMessage("Welcome to Magical Warfare! to start the add-on type 'mwinitiate' in chat. [Ignore this message if you've already done this]")
    }
})

world.afterEvents.projectileHitEntity.subscribe(data => {
    const hitEntity = data.getEntityHit().entity;
    const { projectile } = data;

    if (projectile.typeId === "minecraft:snowball") {
        hitEntity.runCommand("")
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:wraithscythe') {
        player.runCommand('execute at @e[rm=1,r=3,c=1] run summon zk:burn ~~1~') // Player runs the command
        hitEntity.runCommand('effect @s wither 6 1') // Entity runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:greatvoltstrike') {
        player.runCommand('function lightningbladehitthunder') // Player runs the command
        hitEntity.runCommand('effect @s slowness 3 1 true') // Entity runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:lightningzap') {
        player.runCommand('function lightningbladehitthunder') // Player runs the command
        hitEntity.runCommand('effect @s slowness 3 1 true') // Entity runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:greatvoltstrikerise') {
        player.runCommand('function lightningbladehitthunder') // Player runs the command
        hitEntity.runCommand('effect @s slowness 3 1 true') // Entity runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:voltstrikerise') {
        player.runCommand('function lightningbladehitthunder') // Player runs the command
        hitEntity.runCommand('effect @s slowness 3 1 true') // Entity runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:voltstrike') {
        player.runCommand('function lightningbladehitthunder') // Player runs the command
        hitEntity.runCommand('effect @s slowness 3 1 true') // Entity runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:lightningbolt') {
        player.runCommand('function lightningbladehitthunder') // Player runs the command
        hitEntity.runCommand('effect @s slowness 3 1 true') // Entity runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:lightningblitz') {
        player.runCommand('function lightningbladehitthunder') // Player runs the command
        hitEntity.runCommand('effect @s slowness 3 1 true') // Entity runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:bloodlust') {
        player.runCommand('function bloodbladehit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:bloodlustact') {
        player.runCommand('function bloodbladehit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:bloodslasht') {
        player.runCommand('function bloodbladehit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:bloodspikes') {
        player.runCommand('function bloodbladehit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:forcebleed') {
        player.runCommand('function bloodbladehit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:vampiricthirst') {
        player.runCommand('function bloodbladehit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:vampiricthirstact') {
        player.runCommand('function bloodbladehit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:darkwave') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:creaturesofthevoid') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:darkareai') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:darknesscoat') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:darkcrystali') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:darkphantomi') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:darknessbindingrestraints') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:darkshot') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:darkdimensionslash') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:lightlesswavebarrage') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:lightlesswavebarrageactive') {
        player.runCommand('function darkhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:moonbladeslash') {
        player.runCommand('function moonhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:activequadruplemoonbladeslash') {
        player.runCommand('function moonhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:moonbladeswrath') {
        player.runCommand('function moonhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:moonblades') {
        player.runCommand('function moonhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:moonsgrace') {
        player.runCommand('function moonhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:quadruplemoonbladeslash') {
        player.runCommand('function moonhit') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:endrectifier') {
        player.runCommand('function endre') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:firerectifier') {
        player.runCommand('function flamere') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:icerectifier') {
        player.runCommand('function frostre') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:naturerectifier') {
        player.runCommand('function dendrore') // Player runs the command
    }
});

world.afterEvents.entityHitEntity.subscribe(({ hitEntity, damagingEntity: player }) => {
    if (!(player instanceof Player)) return;

    let weapon = player.getComponent('equippable')?.getEquipment('Mainhand');

    if (weapon?.typeId === 'zk:shadowrectifier') {
        player.runCommand('function shadowre') // Player runs the command
    }
});

world.afterEvents.chatSend.subscribe(({ sender, message }) => {
    if (message === "mwinitiate") {
        Initiate(sender)
    }
})

function Initiate(player) {
    player.runCommand("function worldfirstload")
}

world.afterEvents.chatSend.subscribe(({ sender, message }) => {
    if (message === "mproj") {
        Onitiate(sender)
    }
})

function Onitiate(player) {
    player.runCommand("function projs")
}
